#include "CJogoCliente.h"
#include <ctime>
#include <iostream>
using namespace std;

CJogoCliente::CJogoCliente(int numPlayers){
    this->portinari = new CPintor();
	this->fachadaCliente = new CFachadaCliente(numPlayers);
	this->faseAtual = this->fachadaCliente->getFaseAtual();

	 // Barra de HP
	    this->HPBar = load_bitmap("Cliente/Recursos/HPBar1.bmp",NULL);
        this->HPMario = load_bitmap("Cliente/Recursos/HPMario.bmp",NULL);;
        this->HPLuigi = load_bitmap("Cliente/Recursos/HPLuigi.bmp",NULL);;

		// Sprites de mario
		this->arraySpriteMario[0] = load_bitmap("Cliente/Recursos/mario2.bmp",NULL);
		this->arraySpriteMario[1] = load_bitmap("Cliente/Recursos/mario3.bmp",NULL);
		this->arraySpriteMario[2] = load_bitmap("Cliente/Recursos/mario4.bmp",NULL);
		this->arraySpriteMario[3] = load_bitmap("Cliente/Recursos/mario5.bmp",NULL);
		this->arraySpriteMario[4] = load_bitmap("Cliente/Recursos/marioJump.bmp",NULL);

		// Sprite de luigi
		this->arraySpriteLuigi[0] = load_bitmap("Cliente/Recursos/luigi2.bmp",NULL);
		this->arraySpriteLuigi[1] = load_bitmap("Cliente/Recursos/luigi3.bmp",NULL);
		this->arraySpriteLuigi[2] = load_bitmap("Cliente/Recursos/luigi4.bmp",NULL);
		this->arraySpriteLuigi[3] = load_bitmap("Cliente/Recursos/luigi5.bmp",NULL);
		this->arraySpriteLuigi[4] = load_bitmap("Cliente/Recursos/luigiJump.bmp",NULL);

		//Sprite greenKoopa
		this->arraySpriteGreenKoopa[0] =load_bitmap("Cliente/Recursos/greenKoopa1.bmp",NULL);
		this->arraySpriteGreenKoopa[1] = load_bitmap("Cliente/Recursos/greenKoopa2.bmp",NULL);
		this->arraySpriteGreenKoopa[2] = load_bitmap("Cliente/Recursos/greenKoopa3.bmp",NULL);
		this->arraySpriteGreenKoopa[3] = load_bitmap("Cliente/Recursos/greenKoopa4.bmp",NULL);

		// Sprite redKoopa
		this->arraySpriteRedKoopa[0] =load_bitmap("Cliente/Recursos/RedKoopa1.bmp",NULL);
		this->arraySpriteRedKoopa[1] = load_bitmap("Cliente/Recursos/RedKoopa2.bmp",NULL);
		this->arraySpriteRedKoopa[2] = load_bitmap("Cliente/Recursos/RedKoopa3.bmp",NULL);
		this->arraySpriteRedKoopa[3] = load_bitmap("Cliente/Recursos/RedKoopa4.bmp",NULL);

        // Sprite Shyguy
		this->arraySpriteShyguy[0] =load_bitmap("Cliente/Recursos/whiteShyguy1.bmp",NULL);
		this->arraySpriteShyguy[1] = load_bitmap("Cliente/Recursos/whiteShyguy2.bmp",NULL);
		this->arraySpriteShyguy[2] = load_bitmap("Cliente/Recursos/whiteShyguy3.bmp",NULL);
		this->arraySpriteShyguy[3] = load_bitmap("Cliente/Recursos/whiteShyguy4.bmp",NULL);

		//Sprite Bullet
		this->spriteBullet =load_bitmap("Cliente/Recursos/bullet1.bmp",NULL);
        //Sprite bala
		this->spriteBala = load_bitmap("Cliente/Recursos/bala4.bmp",NULL);

		// carregar musica
		this->fase1 =   load_sample("Cliente/Recursos/rap_das_armas.wav");
		this->fase2 = load_sample("Cliente/Recursos/tropa_elite.wav");
		this->ganhou = load_sample("Cliente/Recursos/siri.wav");


		this->carregarCenario();

}

CJogoCliente::~CJogoCliente(){
	delete this->fachadaCliente;
	delete this->cenarioColisao;
	delete []  this->arraySpriteMario;
	delete [] this->arraySpriteLuigi;
	delete [] this->arraySpriteGreenKoopa;
	delete [] this->arraySpriteRedKoopa;
	delete []  this->arraySpriteShyguy;
	delete   this->spriteBullet;
	delete this->spriteBala;
	delete   this->HPBar;
	delete this->HPMario;
	delete  this->HPLuigi;
	delete this->fase1;
	delete this->fase2;
	delete this->ganhou;
}


void CJogoCliente::carregarCenario(){
      this->portinari->limparTela();

      if(this->faseAtual == FASE_1){
			play_sample(this->fase1, 255, 128, 1000,TRUE);
			this->cenarioColisao = load_bitmap("Cliente/Recursos/cenario1Completo.bmp",NULL);

		}
		else if(this->faseAtual == FASE_2){
			stop_sample(this->fase1);
			play_sample(this->fase2, 255, 128, 1000,TRUE);
			this->cenarioColisao = load_bitmap("Cliente/Recursos/cenario2Completo.bmp",NULL);


		}else if(this->faseAtual == GAME_OVER){
		    stop_sample(this->fase1);
			stop_sample(this->fase2);
		     this->cenarioColisao = load_bitmap("Cliente/Recursos/gameOver.bmp", NULL);

		}else if(this->faseAtual == VITORIA){
            stop_sample(this->fase2);
            play_sample(this->ganhou, 255, 128, 1000,TRUE);
		    int vencedor = this->fachadaCliente->getVencedor();
		    if(vencedor == 0){
		    this->cenarioColisao = load_bitmap("Cliente/Recursos/marioVenceu.bmp", NULL);
		    }else if(vencedor == 1){
		    this->cenarioColisao = load_bitmap("Cliente/Recursos/luiggiVenceu.bmp", NULL);
		    }

		}
}

void CJogoCliente::executar(){
	CTeclado *teclado = new CTeclado();
	this->estadoJogo = this->fachadaCliente->getEstadoJogo();

	while(estadoJogo != TERMINADO){
	    double tempoInicial = ((double) clock())/CLOCKS_PER_SEC;

		this->estadoJogo = this->fachadaCliente->getEstadoJogo();
		int entrada = teclado->getEntrada();
		this->fachadaCliente->passarEntrada(entrada);
		this->fachadaCliente->processarEntrada();
        this->cenaAtual = this->fachadaCliente->getCenaAtual();

		// carregar fases
		EFase recebida = this->fachadaCliente->getFaseAtual();
		if(recebida != this->faseAtual){
            this->faseAtual = recebida;
            this->carregarCenario();
		}

		this->portinari->desenharCenario(this->cenarioColisao);

		if(this->estadoJogo != TERMINADO){
			for(int e = 0; e < cenaAtual.numPlayers;e++){
				BITMAP * atual;
				BITMAP * atualvoando;

            if(cenaAtual.dadosPlayers[e].movimento != MORTO){
				if(e == 0){
					if(cenaAtual.dadosPlayers[e].movimento == PARADO) {
						atual = this->arraySpriteMario[0];
					} else {
						atual = this->arraySpriteMario[cenaAtual.dadosPlayers[e].estado];
						atualvoando = this->arraySpriteMario[4];
					}
				  //imprimindo score mario
				  this->portinari->escreverTexto("SCORE DE MARIO",20,50);
				  this->portinari->escreverInteiro(cenaAtual.dadosPlayers[e].score,140,50);
				}else if(e==1){
					if(cenaAtual.dadosPlayers[e].movimento == PARADO) {
						atual = this->arraySpriteLuigi[0];
					} else {
						atual = this->arraySpriteLuigi[(int)cenaAtual.dadosPlayers[e].estado];
						atualvoando = this->arraySpriteLuigi[4];
					}
                     //imprimindo score luigi
				  this->portinari->escreverTexto("SCORE DE LUIGI",590,50);
				  this->portinari->escreverInteiro(cenaAtual.dadosPlayers[e].score,710,50);
				}
				if(cenaAtual.dadosPlayers[e].sentido == DIREITA){
					if(cenaAtual.dadosPlayers[e].movimento == VOANDO){
						this->portinari->desenharObjetos(atualvoando,cenaAtual.dadosPlayers[e].xPos,cenaAtual.dadosPlayers[e].yPos,false);
					}else{
						this->portinari->desenharObjetos(atual,cenaAtual.dadosPlayers[e].xPos,cenaAtual.dadosPlayers[e].yPos,false);
					}

				}
				else if(cenaAtual.dadosPlayers[e].sentido == ESQUERDA){
					if(cenaAtual.dadosPlayers[e].movimento == VOANDO){
						this->portinari->desenharObjetos(atualvoando,cenaAtual.dadosPlayers[e].xPos,cenaAtual.dadosPlayers[e].yPos,true);
					}else{
						this->portinari->desenharObjetos(atual,cenaAtual.dadosPlayers[e].xPos,cenaAtual.dadosPlayers[e].yPos,true);
					}
				}

                //desenhando as barras de HP
                int inicioMarioHPBar = 10;
                int inicioLuigiHPBar = 583;
                if(e == 0)
                    this->portinari->desenharObjetos(this->HPBar,inicioMarioHPBar,10,false);
                else if(e == 1)
                    this->portinari->desenharObjetos(this->HPBar,inicioLuigiHPBar,10,false);

                int hp = cenaAtual.dadosPlayers[e].life;
                BITMAP *hpAPrintar;
                for(int t = 0; t < (hp/10); t++) {
                    int posicaoAPrintar = 5;
                    if(e == 0){
                        posicaoAPrintar = posicaoAPrintar + inicioMarioHPBar + (t*21);
                        hpAPrintar = HPMario;
                    } else if(e == 1){
                        posicaoAPrintar = posicaoAPrintar + (inicioLuigiHPBar + (t*21));
                        hpAPrintar = HPLuigi;
                    }
                   this->portinari->desenharObjetos(hpAPrintar,posicaoAPrintar,15,false);
                }

            }
			}


			int a = 0;
			while(a < cenaAtual.numInimigos){
				BITMAP * inimigoAtual;
				if(cenaAtual.dadosInimigos[a].tipo == 0){
					inimigoAtual = this->spriteBullet;
				}else  if(cenaAtual.dadosInimigos[a].tipo == 1){
					inimigoAtual = this->arraySpriteGreenKoopa[(int)cenaAtual.dadosInimigos[a].estado];
				}else  if(cenaAtual.dadosInimigos[a].tipo == 2){
					inimigoAtual = this->arraySpriteRedKoopa[(int)cenaAtual.dadosInimigos[a].estado];
				}else  if(cenaAtual.dadosInimigos[a].tipo == 3){
					inimigoAtual = this->arraySpriteShyguy[(int)cenaAtual.dadosInimigos[a].estado];
				}
				if(cenaAtual.dadosInimigos[a].sentido == DIREITA){
					this->portinari->desenharObjetos(inimigoAtual,cenaAtual.dadosInimigos[a].xPos,cenaAtual.dadosInimigos[a].yPos,false);
				}else if(cenaAtual.dadosInimigos[a].sentido == ESQUERDA){
					this->portinari->desenharObjetos(inimigoAtual,cenaAtual.dadosInimigos[a].xPos,cenaAtual.dadosInimigos[a].yPos,true);
				}
				a++;
			}


			for(int d = 0; d< cenaAtual.numbalas;d++){
				this->portinari->desenharObjetos(this->spriteBala,cenaAtual.dadosBalas[d].xPos,cenaAtual.dadosBalas[d].yPos,false);
			}



        if(estadoJogo == PAUSADO){
        	this->portinari->escreverTexto("PAUSADO",370,300);
        }

		}
			double tempoFinal = ((double) clock())/CLOCKS_PER_SEC;
            double tempoDeEspera = TEMPO - ((tempoFinal - tempoInicial)*1000);
            if(tempoDeEspera > 0){
                rest(tempoDeEspera);
            }
			this->portinari->showFrame();

	}

}


void CJogoCliente::limparSom(){

    stop_sample(this->ganhou);
    stop_sample(this->fase1);
    stop_sample(this->fase2);
}
