#ifndef CJOGOCLIENTE_H_
#define CJOGOCLIENTE_H_

#include "CFachadaCliente.h"
#include "Basicas/CTeclado.h"
#include "Basicas/CPintor.h"
#include "Enumeracoes/EEstadoJogo.h"
#include "Apoio/SCena.h"

#define TEMPO   40

#define NUM_MAX_PLAYERS   2
#define INIMIGOS_DIFERENTES 4
#define NUM_IMAGES 5

class CJogoCliente{
    private:

        BITMAP *cenarioColisao;
        BITMAP *HPBar;
        BITMAP *HPMario;
        BITMAP *HPLuigi;
        BITMAP *arraySpriteMario[NUM_IMAGES];
        BITMAP *arraySpriteLuigi[NUM_IMAGES];
        BITMAP *arraySpriteGreenKoopa[NUM_IMAGES-1];
        BITMAP *arraySpriteRedKoopa[NUM_IMAGES-1];
        BITMAP *arraySpriteShyguy[NUM_IMAGES-1];
        BITMAP *spriteBullet;
        BITMAP *spriteBala;
        SAMPLE *fase1;
        SAMPLE *fase2;
        SAMPLE *ganhou;

        SCena cenaAtual;
        EFase faseAtual;
        CPintor *portinari;

        void carregarCenario();

    public:
    CFachadaCliente *fachadaCliente;
    EEstadoJogo estadoJogo;
    int getNumPlayers(void);
    void limparSom();

        CJogoCliente(int);
        ~CJogoCliente();

        void executar();
};

#endif
