#ifndef CPERSONAGEM_H_
#define CPERSONAGEM_H_

#include "CObjeto.h"
#include "../Enumeracoes/ESentido.h"
#include "../Enumeracoes/EMovimento.h"
#include "../Enumeracoes/EEstado.h"

/*
Classe abstrata que representa um personagem do jogo, podendo
ser personagem do jogador ou inimigo
*/
class CPersonagem : public CObjeto{
    protected:
        ESentido sentido;
        EMovimento  mov;
        int pontosDeVida, delayTiro;
        int tipo;
        int contadorDeTiros;
        int score;
	    EEstado estado;


    public:
        CPersonagem(int,int,int,int,int,int,ESentido,int,int,int,EEstado,EMovimento, int);

        ESentido getSentido();
        EMovimento getMov();
        void setMov(EMovimento mov);
        int getPontosDeVida();
        int getDelayTiro();
        void setSentido(ESentido);
        void diminuirPontosDeVida(int valor);
        void setDelayTiro(int);
        void incrementarScore(int valor);
        int getTipo(void);
        int getContadorDeTiro();
        int getScore();
        void incrementarContadorDeTiro();
        void setContadorDeTiro(int contador);
	   EEstado getEstado(void);
	   void setEstado(EEstado estado);
};

#endif
