#include "CJogoServidor.h"
#include "Apoio/SCena.h"
#include <iostream>
#include <fstream>
using namespace std;

//construtor
CJogoServidor::CJogoServidor(int numPlayers){
     this->numPlayers = numPlayers;
     this->faseAtual = FASE_1;
     this->carregarFase("Servidor/Recursos/bope_castle.txt", 0, 0);
    this->estadoJogo = RODANDO;
    this->pausePressionado = false;

}

//destrutor
CJogoServidor::~CJogoServidor(void){
	delete [] this->arrayPlayers;
	delete [] this->arrayBalas;
	delete [] this->arrayPlataformas;
	delete [] this->arrayMonstros;
}


//receberEntrada
void CJogoServidor::receberEntrada(int entrada){
	int entradaReg = entrada;
	int entradaDecod = MAIOR_TECLA;
	int entreiEmMenoPausa = false;

	while(entradaDecod != 0){
		if(entradaDecod <= entradaReg){
			entradaReg = entradaReg - entradaDecod;

			ETeclasMapeadas tecla = (ETeclasMapeadas) entradaDecod;
			switch(tecla){
			//codigo para verificar as teclas gerais
			case BACK_KEY:
				this->estadoJogo = TERMINADO;
				this->pausePressionado = false;
				break;
			case SELECT_PAUSE_KEY:
                if(!this->pausePressionado){
                    if(this->estadoJogo == PAUSADO){
                         this->estadoJogo = RODANDO;
                    }else if(this->estadoJogo == RODANDO){
                        this->estadoJogo = PAUSADO;
                    }
                    this->pausePressionado = true;
                }
				entreiEmMenoPausa = true;
				break;
            case CHANGE_STAGE_KEY:
                 this->mudarFase();

            break;
				//codigo para verificar teclas do player 1
			case PLY1_MENU_UP_KEY:
				this->comandoPlayer[0].pular = 1;
				break;
			case PLY1_MENU_LEFT_KEY:
				this->comandoPlayer[0].andarEsquerda = 1;
				break;
			case PLY1_MENU_RIGHT_KEY:
				this->comandoPlayer[0].andarDireita = 1;
				break;
			case PLY1_SHOT_KEY:
				this->comandoPlayer[0].atirar = 1;
				break;
				//codigo para verificar teclas do player 2
			case PLY2_UP_KEY:
				this->comandoPlayer[1].pular = 1;
				break;
			case PLY2_LEFT_KEY:
				this->comandoPlayer[1].andarEsquerda = 1;
				break;
			case PLY2_RIGHT_KEY:
				this->comandoPlayer[1].andarDireita = 1;
				break;
			case PLY2_SHOT_KEY:
				this->comandoPlayer[1].atirar = 1;
				break;
			}
		}

		entradaDecod = entradaDecod/2;
	}

	if(!entreiEmMenoPausa)
        this->pausePressionado = false;
}

//TODO melhorar esse metodo
void CJogoServidor::processarEntrada(){
    //verificando fase do fogo
    if(this->arrayPlayers[0]->getPontosDeVida() <= 0 && this->arrayPlayers[1]->getPontosDeVida() <= 0 && this->numPlayers == 2){
           this->faseAtual = GAME_OVER;
         cout << "GAMEOVER" << endl;
           this->mudarFase();
        }else if(this->arrayPlayers[0]->getPontosDeVida() <= 0 && this->numPlayers == 1){
           this->faseAtual = GAME_OVER;
           cout << "GAMEOVER" << endl;
           this->mudarFase();
        }else if(this->numMonstros == 0 && (this->arrayPlayers[0]->getMov() == MORTO || this->arrayPlayers[1]->getMov() == MORTO)  && this->numPlayers == 2 ){
           this->mudarFase();
        } else if(this->numMonstros == 0  && this->numPlayers == 1 ){
           this->mudarFase();
        }


    if(this->estadoJogo == RODANDO){
        this->movimentarInimigos();

        //Processar movimentos do players
        for(int i = 0; i < this->numPlayers; i++){
            if(this->arrayPlayers[i]->getMov() != MORTO){
                //Adicionar balas caso o player atire
                this->adicionarBalasPlayers(this->arrayPlayers[i],i);
                bool taNoChao = false;
                //Processar movimento no eixo y e retorna se o player esta no chao;
                taNoChao = this->movimentarPlayerEixoY(this->arrayPlayers[i],taNoChao,i);
                //Processar movimento em X
                this->movimentarPlayerEixoX(this->arrayPlayers[i],taNoChao,i);
            }
        }

        this->movimentarBalas();
        this->limparBalas();

    }
}


//mudarFase
void CJogoServidor::mudarFase(){
    switch(this->faseAtual){
        case FASE_1:
            this->faseAtual = FASE_2;
            this->estadoJogo = RODANDO;
            this->carregarFase("Servidor/Recursos/rio_de_janeiro.txt", this->arrayPlayers[0]->getScore(), this->arrayPlayers[1]->getScore());
            break;
        case FASE_2:
            this->faseAtual = VITORIA;
            this->estadoJogo = TERMINADO;
            break;
        case VITORIA:
            this->estadoJogo = TERMINADO;
            break;
        case GAME_OVER:
            this->estadoJogo = TERMINADO;
            break;
    }
}


void CJogoServidor::carregarFase(const char *fase, int scoreMario, int scoreLuiggi){
	// argumentos para criacao dos obejtos

	int xPos, yPos, largura, altura, tipo, pontosDeVida, limiteInicial, limiteFinal, delayTiro;
	ESentido sentido;
	int sent,temp1, temp2;

	ifstream faseFile;
	faseFile.open(fase);

	//carregando Players
	this->arrayPlayers[0] = this->arrayPlayers[1] = NULL;
	for(int i = 0; i < 2; i++){
		faseFile >> xPos; faseFile >> yPos; faseFile >>sent;

		//verificando sentido
		if(sent== 1)
			sentido = DIREITA;
		else
			sentido = ESQUERDA;

		// Obs: mario e luigi com as mesmas alturas.
		// tipo de mario 4 tipo de 5
		if(i == 0){
            this->arrayPlayers[i] = new CPlayer(xPos,yPos,30,30,X_SPEED,0,sentido,LIFE,DELAYTIRO,i,i+4,INICIAL,PARADO, scoreMario);
		}else{
		    this->arrayPlayers[i] = new CPlayer(xPos,yPos,30,30,X_SPEED,0,sentido,LIFE,DELAYTIRO,i,i+4,INICIAL,PARADO, scoreLuiggi);
		}
		this->resetarComandos(i);
	}

	//Armazenando numero de platafromas.
	faseFile >> temp1;
	this->numPlataformas = temp1;
	//criando plataformas
	for(int i = 0; i < this->numPlataformas; i++){
		faseFile >> xPos; faseFile >> yPos; faseFile >>largura; faseFile >>altura;
		this->arrayPlataformas[i] = new CObjeto( xPos, yPos, largura, altura, 0, 0);

	}

	// craindo monstros
	faseFile >> temp2;
	this->numMonstros = temp2;
	for(int i = 0; i < this->numMonstros; i++){
		faseFile >> xPos; faseFile >> yPos; faseFile >>largura; faseFile >>altura;faseFile >>sent;

		//verificando sentido
		if(sent== 1)
			sentido = DIREITA;
		else
			sentido = ESQUERDA;

		faseFile >>pontosDeVida; faseFile >> delayTiro; faseFile >>limiteInicial; faseFile >>limiteFinal;faseFile >> tipo;
		this->arrayMonstros[i] = new CInimigo( xPos, yPos, largura, altura, X_SPEED, 0, sentido, pontosDeVida,delayTiro,limiteInicial,limiteFinal,tipo,INICIAL,ANDANDO);
	}
}

SCena CJogoServidor::getCenaAtual(){
	for(int i = 0; i < this->numPlayers; i++){
		if(this->arrayPlayers[i] != NULL){
			this->cena.dadosPlayers[i].xPos = this->arrayPlayers[i]->getPosicao(EIXO_X);
			this->cena.dadosPlayers[i].yPos = this->arrayPlayers[i]->getPosicao(EIXO_Y);
			this->cena.dadosPlayers[i].estado = this->arrayPlayers[i]->getEstado();
			this->cena.dadosPlayers[i].tipo = this->arrayPlayers[i]->getTipo();
			this->cena.dadosPlayers[i].score = this->arrayPlayers[i]->getScore();
			this->cena.dadosPlayers[i].life = this->arrayPlayers[i]->getPontosDeVida();
			this->cena.dadosPlayers[i].sentido = this->arrayPlayers[i]->getSentido();
			this->cena.dadosPlayers[i].movimento = this->arrayPlayers[i]->getMov();

		}
	}

	for(int d = 0; d < this->numMonstros; d++){
		this->cena.dadosInimigos[d].xPos = this->arrayMonstros[d]->getPosicao(EIXO_X);
		this->cena.dadosInimigos[d].yPos = this->arrayMonstros[d]->getPosicao(EIXO_Y);
		this->cena.dadosInimigos[d].estado = this->arrayMonstros[d]->getEstado();
		this->cena.dadosInimigos[d].tipo = this->arrayMonstros[d]->getTipo();
		// por default score  de mostro 0
		this->cena.dadosInimigos[d].score = 0;
		this->cena.dadosInimigos[d].life = this->arrayMonstros[d]->getPontosDeVida();
		this->cena.dadosInimigos[d].sentido = this->arrayMonstros[d]->getSentido();
		this->cena.dadosInimigos[d].movimento = this->arrayMonstros[d]->getMov();
	}


	for(int d = 0; d < this->numBalas; d++){
		this->cena.dadosBalas[d].xPos = this->arrayBalas[d]->getPosicao(EIXO_X);
		this->cena.dadosBalas[d].yPos = this->arrayBalas[d]->getPosicao(EIXO_Y);
		this->arrayBalas[d]->setColidiu(false);
	}


	this->cena.numInimigos = this->numMonstros;
	this->cena.numPlayers = this->numPlayers;
	this->cena.numbalas = this->numBalas;

	return this->cena;
}


EEstadoJogo CJogoServidor::getEstadoJogo(){
	return this->estadoJogo;
}

void CJogoServidor::setEstadoJogo(EEstadoJogo estadoAtual){
	this->estadoJogo = estadoAtual;
}


EFase CJogoServidor::getFaseAtual(){
	return this->faseAtual;
}


bool CJogoServidor::movimentarPlayerEixoY(CPlayer * player, bool taNoChao, int i){

	int ySpeed = player->getVelocidade(EIXO_Y);
	ySpeed = ySpeed + GRAVIDADE;
	int yPos = player->getPosicao(EIXO_Y);
	bool colidiu = false;
	//Analise e Ajuste de colises com plataformas horizontais.
	for(int e = 0; e<this->numPlataformas;e++){
		if(this->colisaoPlataformas(player,this->arrayPlataformas[e],EIXO_Y)){
			colidiu = true;
			ySpeed = 0;
			taNoChao = true;
			player->setVelocidade(0,EIXO_Y);
			if(this->comandoPlayer[i].pular){
				ySpeed = JUMP_SPEED;
				player->setMov(VOANDO);
			}
		}
	}
	if(!colidiu){
		yPos = yPos + ySpeed;
		player->setPosicao(yPos,EIXO_Y);
		player->setMov(VOANDO);
	}
	player->setVelocidade(ySpeed,EIXO_Y);

	return taNoChao;
}


void CJogoServidor::movimentarPlayerEixoX(CPlayer * player, bool taNoChao,int i){
	int a;
	if(this->comandoPlayer[i].andarDireita && this->comandoPlayer[i].andarEsquerda){
		a = (int) player->getSentido();
		if(taNoChao){
			this->incrementarEstado(player);
		}
	}
	else{
		a = this->comandoPlayer[i].andarDireita - this->comandoPlayer[i].andarEsquerda;
		int sentido = (int) player->getSentido();
		if(a == 0 && taNoChao) {
			player->setMov(PARADO);
		} else if(a == 1 || a == -1){
			player->setSentido((ESentido) a);
			if(taNoChao){
				player->setMov(ANDANDO);
				if(sentido == a) {
					this->incrementarEstado(player);
				} else if (sentido != a) {
					//estadoAtual = INICIAL;
					player->setMov(PARADO);
					player->setEstado(INICIAL);
				}
			}
		}
	}

	int xPos = player->getPosicao(EIXO_X);
	int xSpeed = player->getVelocidade(EIXO_X);
	// Quando for player segundo e quarto argumento = 0
	if(!this->colidirParede(player,0,a,0)){
		bool colidiu2 = false;
		for(int e = 0; e<this->numPlataformas;e++){
			if(this->colisaoPlataformas(player,this->arrayPlataformas[e],EIXO_X)){
				colidiu2 = true;
				xSpeed = 0;
			}
		}
		if(!colidiu2){
			player->setPosicao(xPos + a*xSpeed,EIXO_X);
		}
	}

	this->resetarComandos(i);

}

void CJogoServidor::resetarComandos(int i){
	this->comandoPlayer[i].pular = 0;
	this->comandoPlayer[i].atirar = 0;
	this->comandoPlayer[i].andarDireita = 0;
	this->comandoPlayer[i].andarEsquerda = 0;
}

void CJogoServidor::adicionarBalasPlayers(CPlayer * player, int i){
        if(this->comandoPlayer[i].atirar && player->getDelayTiro() ==  player->getContadorDeTiro()){
            this->inserirBalas(player->getSentido(),player->getPosicao(EIXO_X),
            player->getPosicao(EIXO_Y),player->getDimensao(EIXO_Y),
            player->getDimensao(EIXO_X), i,player->getTipo());
            player->setContadorDeTiro(0);
        } else {
            player->incrementarContadorDeTiro();
        }
}

bool CJogoServidor::colidirParede(CObjeto *objeto, int tipoDeObjeto,int a, int posBala){
	// tipoDeObejto = 0 mario; tipoDeObejto = 1 bala;

	bool colidiu= false;
	int xPos = objeto->getPosicao(EIXO_X);
	int xSpeed = objeto->getVelocidade(EIXO_X);
	//objeto->setVelocidade(xSpeed,EIXO_X);
	if((xPos + a*xSpeed) < 0){
		if(tipoDeObjeto == 0){
            objeto->setPosicao(0,EIXO_X);
		}
		colidiu= true;
	} else if((xPos + objeto->getDimensao(EIXO_X) + a*xSpeed) > 800){
		if(tipoDeObjeto == 0){
            objeto->setPosicao((800 - objeto->getDimensao(EIXO_X)),EIXO_X);
		}
		colidiu= true;
	}

	if(colidiu  && tipoDeObjeto == 1){
		this->arrayBalas[posBala]->setColidiu(true);
		this->arrayBalas[posBala]->setPosicao(-100,EIXO_X);
	}

	return colidiu;
}



bool CJogoServidor::colisaoPlataformas(CPersonagem *personagem, CObjeto *plataforma, EEixo eixo){
        bool retorno = false;
        int xPosPersonagem = personagem->getPosicao(EIXO_X);
        int yPosPersonagem = personagem->getPosicao(EIXO_Y);
        int alturaPersonagem = personagem->getDimensao(EIXO_Y);
        int larguraPersonagem = personagem->getDimensao(EIXO_X);
        int xPosPlataforma = plataforma->getPosicao(EIXO_X);
        int yPosPlataforma = plataforma->getPosicao(EIXO_Y);
        int alturaPlataforma = plataforma->getDimensao(EIXO_Y);
        int larguraPlataforma = plataforma->getDimensao(EIXO_X);

        if(eixo == EIXO_X){
            if(larguraPlataforma == 0){
                int sentido = (int) personagem->getSentido();
                int velocidade = personagem ->getVelocidade(EIXO_X);
                if((yPosPersonagem+alturaPersonagem >= yPosPlataforma) && (yPosPersonagem <= (yPosPlataforma+alturaPlataforma))){
                    if((xPosPersonagem+larguraPersonagem <= xPosPlataforma) &&  (xPosPersonagem+larguraPersonagem+sentido*velocidade > xPosPlataforma)){
                        personagem->setPosicao(xPosPlataforma-larguraPersonagem , EIXO_X);
                        retorno = true;
                    } else if((xPosPersonagem >= xPosPlataforma) &&  (xPosPersonagem+sentido*velocidade < xPosPlataforma)){
                        personagem->setPosicao(xPosPlataforma , EIXO_X);
                        retorno = true;
                    }
                }
            }
        } else {
            if(alturaPlataforma == 0){
                int velocidade = personagem->getVelocidade(EIXO_Y);
                if((xPosPersonagem+larguraPersonagem >= xPosPlataforma) && (xPosPersonagem <= (xPosPlataforma+larguraPlataforma))){
                    if((yPosPersonagem+alturaPersonagem <= yPosPlataforma) && (yPosPersonagem+alturaPersonagem+velocidade >= yPosPlataforma)){
                        personagem->setPosicao(yPosPlataforma - alturaPersonagem , EIXO_Y);
                        retorno = true;

                    }
                }
            }
        }
        return retorno;
    }


void CJogoServidor::movimentarInimigos(){
	for(int i = 0; i < this->numMonstros; i++){
		int posAtual = this->arrayMonstros[i]->getPosicao(EIXO_X);
		int xSpeed = this->arrayMonstros[i]->getVelocidade(EIXO_X);
		int limiteFinal = this->arrayMonstros[i]->getLimiteFinal();
		int limiteInicial = this->arrayMonstros[i]->getLimiteInicial();
		int proxPos;
		int largura = this->arrayMonstros[i]->getDimensao(EIXO_X);

		//detectar com players
		bool passouEmBranco = true;
		for(int e  = 0; e < this->numPlayers; e++){
			if(this->detectarPlayers(this->arrayMonstros[i],this->arrayPlayers[e])&& this->arrayMonstros[i]->getDelayTiro() ==  this->arrayMonstros[i]->getContadorDeTiro()){

				this->inserirBalas(this->arrayMonstros[i]->getSentido(),this->arrayMonstros[i]->getPosicao(EIXO_X),
						this->arrayMonstros[i]->getPosicao(EIXO_Y),this->arrayMonstros[i]->getDimensao(EIXO_Y), this->arrayMonstros[i]->getDimensao(EIXO_X), -1,this->arrayMonstros[i]->getTipo());
				this->arrayMonstros[i]->setContadorDeTiro(0);
				passouEmBranco = false;
			}
		}

		if (passouEmBranco){
			this->arrayMonstros[i]->incrementarContadorDeTiro();
		}

		if(this->arrayMonstros[i]->getSentido() == DIREITA){
			proxPos = posAtual+xSpeed;
			if(posAtual+largura == limiteFinal){
				this->arrayMonstros[i]->setSentido(ESQUERDA);
				this->arrayMonstros[i]->setMov(PARADO);
			} else if(proxPos+largura >= limiteFinal){
				this->arrayMonstros[i]->setPosicao(limiteFinal-largura, EIXO_X);
				this->incrementarEstado(this->arrayMonstros[i]);
			} else if(proxPos+largura < limiteFinal){
				this->arrayMonstros[i]->setPosicao(proxPos,EIXO_X);
				this->incrementarEstado(this->arrayMonstros[i]);
			}

		} else if(this->arrayMonstros[i]->getSentido() == ESQUERDA){
			proxPos = posAtual-xSpeed;
			if(posAtual == limiteInicial){
				this->arrayMonstros[i]->setSentido(DIREITA);
				this->arrayMonstros[i]->setMov(PARADO);
			} else if(proxPos <= limiteInicial){
				this->arrayMonstros[i]->setPosicao(limiteInicial,EIXO_X);
				this->incrementarEstado(this->arrayMonstros[i]);
			} else if(proxPos > limiteInicial){
				this->arrayMonstros[i]->setPosicao(proxPos,EIXO_X);
				this->incrementarEstado(this->arrayMonstros[i]);
			}
		}
	}

}

void CJogoServidor::movimentarBalas(){
	for(int i = 0; i < this->numBalas; i++){
		int posAtual = this->arrayBalas[i]->getPosicao(EIXO_X);
		int xSpeed = this->arrayBalas[i]->getVelocidade(EIXO_X);
		int proxPos;
		if(this->arrayBalas[i]->getSentido() == DIREITA){
			proxPos = posAtual+xSpeed;
		}else if(this->arrayBalas[i]->getSentido() == ESQUERDA){
			proxPos = posAtual-xSpeed;
		}
		if(!this->colidirParede(this->arrayBalas[i],1,this->arrayBalas[i]->getSentido(),i))
			this->arrayBalas[i]->setPosicao(proxPos,EIXO_X);

        this->colidirPersonagemBala(this->arrayBalas[i],i);
	}

}

bool CJogoServidor::detectarPlayers(CInimigo *inimigo,CPlayer * player){
	bool retorno = false;
	int yposPlayer = player->getPosicao(EIXO_Y);
	int yposInimigo = inimigo->getPosicao(EIXO_Y) + (inimigo->getDimensao(EIXO_Y)/3);
	int altura = player->getDimensao(EIXO_Y);
	bool estaNaFrente = false;
	if(inimigo->getSentido() == DIREITA && player->getPosicao(EIXO_X) >= inimigo->getPosicao(EIXO_X) ){
		estaNaFrente = true;
	}else if(inimigo->getSentido() == ESQUERDA && player->getPosicao(EIXO_X) <= inimigo->getPosicao(EIXO_X)){
		estaNaFrente = true;
	}


	if(yposInimigo >= yposPlayer && yposInimigo <= yposPlayer + altura && estaNaFrente){
		retorno = true;
	}
	return retorno;
}



void CJogoServidor::inserirBalas(ESentido sentido, int xPos,int yPos, int largura, int comprimento, int idDono, int tipo){
	// OBs idDono = 0 mario, idDono = 1 luigi, idDono = -1 inimigo;
	int xBala;
	int yBala = yPos + (largura/3);
	int dano;
	if(tipo == 0)
    dano = 20;
	else if(tipo > 0)
	dano =  10;

	if(sentido == DIREITA){
		xBala = xPos+comprimento+1;
		this->arrayBalas[this->numBalas] = new CBala(xBala, yBala, 8, 8, X_SPEED_BALA, 0, dano, idDono,sentido);
	}else if(sentido == ESQUERDA){
		xBala = xPos-1;
		this->arrayBalas[this->numBalas] = new CBala(xBala, yBala, 8, 8, X_SPEED_BALA, 0, dano, idDono,sentido);
	}
	this->numBalas++;
}

void CJogoServidor::incrementarEstado(CPersonagem *personagem){
	EEstado estadoAtual = personagem->getEstado();
	switch(estadoAtual){
	case INICIAL :
		personagem->setEstado(PASSO1);
		break;
	case PASSO1 :
		personagem->setEstado(PASSO2);
		break;
	case PASSO2 :
		personagem->setEstado(PASSO3);
		break;
	case PASSO3 :
		personagem->setEstado(INICIAL);
		break;
	}
}


void CJogoServidor::removerBala(int pos){
    //cout << this->arrayBalas[pos]->getIdDono() << endl;
    //cout << this->arrayBalas[(this->numBalas-1)]->getIdDono() << endl;
    if(numBalas > 1){
        //cout << "laalala \n";
        this->arrayBalas[pos] = this->arrayBalas[(this->numBalas-1)];
        this->arrayBalas[(this->numBalas-1)] = NULL;
    } else if (numBalas == 1) {
        this->arrayBalas[pos] = NULL;
    }

	this->numBalas--;

}

void CJogoServidor::removerPlayer(int pos){
	this->arrayPlayers[pos]->setMov(MORTO);
	//cemiterio da tela
	// pois mario apos a morte pode continuar na tela causando coliso.
	this->arrayPlayers[pos]->setPosicao(800,EIXO_X);
	this->arrayPlayers[pos]->setPosicao(600,EIXO_Y);

}


void CJogoServidor::removerMonstro(int pos){
	this->arrayMonstros[pos] = this->arrayMonstros[this->numMonstros-1];
	this->numMonstros--;
}



bool CJogoServidor::detectarColisaoPersonagemBala(CPersonagem* personagem,CBala *bala){

    bool retorno = true;
    int larguraA = personagem->getDimensao(EIXO_X);
    int larguraB = bala->getDimensao(EIXO_X);
    int alturaA = personagem->getDimensao(EIXO_Y);
    int alturaB = bala->getDimensao(EIXO_Y);


    int posAtualAX = personagem->getPosicao(EIXO_X);
    int posAtualAY = personagem->getPosicao(EIXO_Y);
    int posAtualBX =  bala->getPosicao(EIXO_X);
    int posAtualBY =  bala->getPosicao(EIXO_Y);


     if(posAtualAX > posAtualBX + larguraB)
     retorno = false;
     if(posAtualAY >  posAtualBY + alturaB)
     retorno = false;
     if(posAtualAX + larguraA < posAtualBX)
     retorno = false;
     if(posAtualAY + alturaA < posAtualBY)
     retorno = false;

return retorno;

}

void CJogoServidor::imprimirColisao(int tipoPersonagem, CPersonagem *personagem){
      if(tipoPersonagem == 4){
        cout << "mario atingido life: " << this->arrayPlayers[0]->getPontosDeVida() << endl;
        }else if(tipoPersonagem == 5){
         cout << "luigi atingido life: " << this->arrayPlayers[1]->getPontosDeVida() << endl;
        }else if(tipoPersonagem == 0){
         cout << "bullet atingido life: " << personagem->getPontosDeVida() << endl;
         }else if(tipoPersonagem == 1){
         cout << "greenKoopa atingido life: " << personagem->getPontosDeVida() << endl;
         }else if(tipoPersonagem == 2){
         cout << "redKoopa atingido life: " << personagem->getPontosDeVida() << endl;
         }else if(tipoPersonagem == 3){
         cout << "Shyguy atingido life: " << personagem->getPontosDeVida() << endl;
         }
}


void CJogoServidor::ajustarColisaoPersonagemBala(CPersonagem *personagem,CBala *bala, int pos, int posPersonagem){
    int idDono = bala->getIdDono();
    int tipoPersonagem = personagem->getTipo();
    int danoBala = bala->getDano();
    if(idDono  == 0){ // mario dono da bala
        personagem->diminuirPontosDeVida(danoBala); // diminui life do antigido;
        if(personagem->getPontosDeVida() <= 0){
            if(personagem->getTipo() < 4){
                this->arrayPlayers[0]->incrementarScore(40);
            }else{
                this->arrayPlayers[0]->incrementarScore(150);
            }
        }else{
            this->arrayPlayers[0]->incrementarScore(10);
        }
        cout << "mario matou score: " << this->arrayPlayers[0]->getScore() << endl;
    } else if(idDono == 1){ // luigi dono da bala
        personagem->diminuirPontosDeVida(danoBala); // diminui life do antigido;
        if(personagem->getPontosDeVida() <= 0){
            if(personagem->getTipo() < 4){
                this->arrayPlayers[1]->incrementarScore(40);
            }else{
                this->arrayPlayers[1]->incrementarScore(150);
            }
        }else{
            this->arrayPlayers[1]->incrementarScore(10);
        }
        cout << "luigi matou score: " << this->arrayPlayers[1]->getScore() << endl;


    } else if(idDono == -1){ // monstro dono da bala
        personagem->diminuirPontosDeVida(danoBala); // diminui life do antigido;

    }

    //this->imprimirColisao(tipoPersonagem,personagem);
    this->arrayBalas[pos]->setColidiu(true);

    if(personagem->getPontosDeVida() <= 0)
        this->removerPersonagem(posPersonagem,tipoPersonagem);

}


void CJogoServidor::colidirPersonagemBala(CBala *bala, int pos){

    for(int i = 0; i < this->numPlayers; i++){
        if(this->detectarColisaoPersonagemBala(this->arrayPlayers[i], bala))
            this->ajustarColisaoPersonagemBala(this->arrayPlayers[i],bala,pos,i);
    }
    for(int d = 0; d < this->numMonstros; d++){
       if(this->detectarColisaoPersonagemBala(this->arrayMonstros[d], bala))
            this->ajustarColisaoPersonagemBala(this->arrayMonstros[d],bala,pos,d);
    }

}


void CJogoServidor::removerPersonagem(int posPersonagem,int tipoPersonagem){
    if(tipoPersonagem < 4)
    this->removerMonstro(posPersonagem);
    else
    this->removerPlayer(posPersonagem);

}


int CJogoServidor::getVencedor(){
    if(this->arrayPlayers[0]->getScore() >= this->arrayPlayers[1]->getScore()){
            return 0;
    }else{
            return 1;
    }
}

void CJogoServidor::limparBalas(){
    for(int i = 0; i < this->numBalas; i++){
        while(this->arrayBalas[i] != NULL && this->arrayBalas[i]->getColidiu()){
            if(this->numBalas == 0){
                break;
            } else{
                 this->removerBala(i);

            }
        }
    }
}
