#ifndef CJOGOSERVIDOR_H_
#define CJOGOSERVIDOR_H_

#include <iostream>

#include "Enumeracoes/ETeclasMapeadas.h"
#include "Apoio/SComando.h"
#include "Enumeracoes/EEStadoJogo.h"
#include "Enumeracoes/EFase.h"
#include "Basicas/CPlayer.h"
#include "Basicas/CBala.h"
#include "Basicas/CInimigo.h"
#include "Basicas/CObjeto.h"
#include "Basicas/CHeap.h"
#include "Apoio/SCena.h"
#include "Apoio/SObjeto.h"

#define MAX_PLAYER      2
#define MAX_INIMIGOS 10
#define MAX_BALAS 1000
#define MAX_PLATAFORMAS 16
#define LIFE            100
#define DELAYTIRO       8
#define X_SPEED          5
#define X_SPEED_BALA     15
#define DANO_BALA        3
#define JUMP_SPEED      -15
#define GRAVIDADE       1

class CJogoServidor{
    private:
        int numPlayers, numMonstros, numBalas, numPlataformas, numObejtos;
        bool pausePressionado;
        CPlayer * arrayPlayers[MAX_PLAYER];
        CInimigo * arrayMonstros[MAX_INIMIGOS];
        CBala * arrayBalas[MAX_BALAS];
        CObjeto * arrayPlataformas[MAX_PLATAFORMAS];
        struct SComando comandoPlayer[MAX_PLAYER];
        SCena cena;
        EEstadoJogo estadoJogo;
        EFase faseAtual;


    public:
        CJogoServidor(int);
        ~CJogoServidor();

        void receberEntrada(int);
        void processarEntrada();
        void carregarFase(const char *, int scoreMario, int scoreLuiggi);
        EFase getFaseAtual();
        SCena getCenaAtual();
        EEstadoJogo getEstadoJogo();
        void removerPlayer(int pos);
        void removerMonstro(int pos);
        int getVencedor(void);
        void mudarFase(void);
        void setEstadoJogo(EEstadoJogo estadoAtual);



    private:
    bool movimentarPlayerEixoY(CPlayer * player, bool taNoChao,int i);
    void movimentarPlayerEixoX(CPlayer * player, bool taNoChao,int i);
    void resetarComandos(int i);
    void adicionarBalasPlayers(CPlayer * player,int i);
    bool colidirParede(CObjeto *objeto, int tipoDeObjeto,int a,int posBala);
    bool colisaoPlataformas(CPersonagem *personagem, CObjeto *plataforma, EEixo eixo);
    void movimentarInimigos();
    void movimentarBalas();
    bool detectarPlayers(CInimigo * inimigo, CPlayer * player);
    void inserirBalas(ESentido sentido, int xPos,int yPos, int largura, int comprimento, int idDono, int tipo);
    void incrementarEstado(CPersonagem *personagem);
    void removerBala(int pos);
    bool detectarColisaoPersonagemBala(CPersonagem* personagem,CBala *bala);
    void imprimirColisao(int tipoPersonagem, CPersonagem *personagem);
    void ajustarColisaoPersonagemBala(CPersonagem *personagem,CBala *bala, int pos, int posPersonagem);
    void colidirPersonagemBala(CBala *bala, int pos);
    void removerPersonagem(int posPersonagem,int tipoPersonagem);
    void limparBalas();


};

#endif
